; $Id: dcs_dec2bin.pro,v 1.3 2002/07/13 20:14:57 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
function dcs_dec2bin,decimal
;************************************************************************************************
; This function returns a string of bits corresponding to a decimal input integer.
; For example dcs_dec2bin(9999) returns the 20-character string "010 011 100 001 111 ".
;
compile_opt strictarr
;
octal=string(decimal,format='(o)'); convert to octal.
lstr=strlen(octal); length of octal string.
outbit=''
;
; Treat each octal number, replacing it with a 4-character string.
for i=0,lstr-1 do begin
	x=strmid(octal,i,1)
	case x of
		'0': outbit=outbit+'000 '
		'1': outbit=outbit+'001 '
		'2': outbit=outbit+'010 '
		'3': outbit=outbit+'011 '
		'4': outbit=outbit+'100 '
		'5': outbit=outbit+'101 '
		'6': outbit=outbit+'110 '
		'7': outbit=outbit+'111 '
		else: outbit=''
	endcase
endfor
;
return,outbit
end