; $Id: dm_center_kid.pro,v 1.4 2003/09/12 19:09:03 qiuym Exp $
; Center kid widget over parent widget. If the parent is not specified, then the kid is centered over the screen
; usuage:
;   dm_center_kid,kid,parent
pro dm_center_kid,kid,parent,_extra=_extra
    if n_elements(kid) eq 0 then kid=0L
    if n_elements(parent) eq 0 then parent=0L
    if widget_info(kid,/valid_id) eq 0 then return
    if widget_info(parent,/valid_id) eq 0 then begin
       device,get_screen_size=center
       center=center/2.
    endif else begin
       geom=widget_info(parent,/geometry)
       center=[geom.xoffset+geom.scr_xsize/2.,geom.yoffset+geom.scr_ysize/2.]
    endelse
    geom=widget_info(kid,/geometry)
    widget_control,kid,xoffset=(0>(center[0]-geom.scr_xsize/2.)),yoffset=(0>(center[1]-geom.scr_ysize/2.)),_extra=_extra
end