; $Id: dm_ispower2.pro,v 1.4 2003/09/26 14:51:25 qiuym Exp $
; check if a positive integer number is power of 2
function dm_ispower2,x
    tmp0 = abs(x)
    if tmp0 eq 0 then return,0              ;0
    tmp1 = fix(tmp0,type=15)                ;unsigned long64
    if abs(tmp0-tmp1) gt 1e-6 then return,0 ;not an integer
    tmp2 = fix(alog(tmp1)/alog(2)+0.5)
    tmp3 = (2ULL)^tmp2
    if abs(tmp1-tmp3) gt 0 then return,0    ;not a power of 2
    return,1
end