; $Id: dm_widget_droplist.pro,v 1.2 2003/09/24 20:03:02 qiuym Exp $
; this program creates a widget_droplist for IDL5.5 or before, or a widget_combobox for IDL5.6 or later
; parameter:
;   parent:     the widget ID of the parent for the new button widget
; keyword:
;   select:     the item number selected at creation
;   all keywords available for widget_droplist and widget_combobox
function dm_widget_droplist,parent,select=select,_extra=extra
    if float(!version.release) ge 5.6 then begin
       ;id=widget_combobox(parent,_extra=extra)
       id=call_function('widget_combobox',parent,_extra=extra)
       if n_elements(select) ne 0 then widget_control,id,set_combobox_select=select
    endif else begin
       id=widget_droplist(parent,_extra=extra)
       if n_elements(select) ne 0 then widget_control,id,set_droplist_select=select
    endelse
    return,id
end