; $Id: dm_write_phx.pro,v 1.4 2003/09/12 19:10:39 qiuym Exp $
; writing a detector profile file(*.phx) named as detfile, this file is used for matlab mslice
; Yiming Qiu 12/19/2002
pro dm_write_phx,detfile,tt,dtt,psi,dpsi
    openw,unit,detfile,/get_lun,error=openerr
    if openerr ne 0 then begin
       ok=dialog_message("Can't write in "+detfile+'.',/error)
       return
    endif
    ndet=n_elements(tt)
    printf,unit,ndet,format='(i3)' ;first line, # of detectors
    for i=0,ndet-1 do $
       printf,unit,10,0,tt[i],psi[i],dtt[i],dpsi[i],i,format='(2(f4.1),4(f7.2),i4)'
    free_lun,unit
end