; $Id: dm_write_spe.pro,v 1.4 2003/10/10 14:12:21 qiuym Exp $
; write into a spe file
pro dm_write_spe,funit,twotheta,emean,qty,err
    sformat = '(8(g10.3))'
    sformat1= '(8(g10.5))'
    n_e  = n_elements(emean)
    n_th = n_elements(twotheta)
    printf,funit,n_th,n_e,format='(2i5)'

    ;write phi grid
    printf,funit,'### Phi Grid'
    printf,funit,[twotheta,0],format=sformat1

    ;write energy grid
    printf,funit,'### Energy Grid'
    printf,funit,[emean,2.0*emean[n_e-1]-emean[n_e-2]],format=sformat

    ;write S(det,energy) and Err(det,energy)
    for i=long(0),n_th-1 do begin
       printf,funit,'### S(Phi,w)'
       printf,funit,qty[*,i],format=sformat
       printf,funit,'### Errors'
       printf,funit,err[*,i],format=sformat
    endfor
end