; $Id: pan_autogaussian.pro,v 1.1 2003/10/24 00:17:44 dimeo Exp $
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function pan_autogaussian,x,parms,$
                     parmnames = parmnames, $
                     canDraw = canDraw, $
                     drawMessage = drawMessage, $
                     _Extra = extra

if n_params() eq 0 then begin
  parmnames = ['area','center','FWHM','bg']
  return,-1
endif
fwhm = parms[2]
sig = fwhm/2.354
area = parms[0]
cen = parms[1]
bg = parms[3]
yout = (area/sqrt(2.0*!dpi*sig^2))*exp(-0.5*((x-cen)/sig)^2) + bg
canDraw = 0
return,yout
end