pro dcs_getcentroid,summed_int,peakfrac,tstart,tstop,tcentroid,error
error=0
maxsummed_int=max(summed_int)
maxch=where(maxsummed_int eq summed_int,count)
if (count ne 1) then begin
	print,"More than one channel has peak intensity"
	error=1
	return
endif
channels=where(summed_int ge peakfrac*maxsummed_int,nchannels)
if (nchannels le 3) then begin
	print,"Too few channels in range determined by peakfrac."
	error=2
	return
endif
lchannel=channels[0]
rchannel=channels[nchannels-1]
tmean=(tstart+tstop)*0.5
twid=tstop-tstart
moment0=total(summed_int[lchannel:rchannel]*twid[lchannel:rchannel])
moment1=total(summed_int[lchannel:rchannel]*twid[lchannel:rchannel]*(tmean[lchannel:rchannel]-tmean[maxch[0]]))
tcentroid=moment1/moment0+tmean[maxch[0]]
end