; $Id: dm_mask_detbanks.pro,v 1.4 2003/10/10 14:14:07 qiuym Exp $
; mask detector banks
; parameter:
;   banks:    bank number to be masked -1:lower  0:central    1:upper
function dm_mask_detbanks,banks
    ;det_file = file_which('dcs_DetPos2.dat',/include_current_dir)
    ;openr,unit,det_file,/get_lun
    ;tmp      = ''    & ndet=913
    ;readf,unit,tmp    ;skip first line
    ;tmp      = strsplit(tmp,' ',/extract)
    ;ncol     = n_elements(tmp)
    ;tmp      = fltarr(ncol,ndet)
    ;readf,unit,tmp
    ;free_lun,unit
    ;banknum  = reform(tmp[ncol-3,*])
    banknum=[$
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1,$
        0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1,$
        1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,-1,-1, 1, 1, 0, 0,$
       -1,-1, 0, 0, 1, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1,$
       -1, 0, 1,-1, 0, 1,-1, 0, 1,-1, 0, 1, 0]
    for i=0,n_elements(banks)-1 do begin
       if abs(banks[i]) le 1 then begin
         if n_elements(mask) eq 0 then $
          mask = where(banknum eq banks[i]) $
         else $
          mask = [mask,where(banknum eq banks[i])]
       endif
    endfor
    if n_elements(mask) eq 0 then mask=-1
    mask = mask[sort(mask)]
    return,mask
end

