; $Id: dm_set_droplist.pro,v 1.1 2003/09/04 21:13:21 qiuym Exp $
; this program sets values for widget_droplist(IDL5.5 or before), or for widget_combobox(IDL5.6 or later)
; parameter:
;   parent:     the widget ID of the parent for the new button widget
; keyword:
;   select:     =set_combobox_select keyword for combobox, =set_droplist_select for droplist
pro dm_set_droplist,id,select=select,_extra=_extra
    if n_elements(id) eq 0 then return
    if float(!version.release) ge 5.6 then begin
       if n_elements(select) ne 0 then widget_control,id,set_combobox_select=select,_extra=_extra
    endif else begin
       if n_elements(select) ne 0 then widget_control,id,set_droplist_select=select,_extra=_extra
    endelse
end
