; $Id: dm_toggle_menubut.pro,v 1.3 2003/04/10 23:58:10 qiuym Exp $
; this program check menu buttons according to IDL version
; for v5.6 and later, a check will be applied(checked) or cancelled(unchecked)
; for v5.5 and before,the button will be unsensitized(checked) or sensitized(unchecked)
; usuage:
;	dm_toggle_menubut,check_but_id,uncheck_but_id
; parameters:
;	check_but_id:   the button id(s) to be checked
;	uncheck_but_id:	the button id(s) to be unchecked
;Yiming Qiu 1/27/2003
pro dm_toggle_menubut,check_but_id,uncheck_but_id
	if float(!version.release) ge 5.6 then begin
		for i=0,n_elements(check_but_id)-1 do $
			widget_control,check_but_id[i],set_button=1
		for i=0,n_elements(uncheck_but_id)-1 do $
			widget_control,uncheck_but_id[i],set_button=0
	endif else begin
		for i=0,n_elements(check_but_id)-1 do $
			widget_control,check_but_id[i],sensitive=0
		for i=0,n_elements(uncheck_but_id)-1 do $
			widget_control,uncheck_but_id[i],sensitive=1
	endelse
end