; $Id: dm_widget_button.pro,v 1.1 2003/09/04 21:13:21 qiuym Exp $
; this program creates a widget_button,checked_menu keyword is set for IDL 5.6 or later
; parameter:
;   parent:     the widget ID of the parent for the new button widget
; keyword:
;   set_button:   initial check state of the button
;   onstring: button value when set_button=1 for IDL5.5 or before
;   offstring:    button value when set_button=0 for IDL5.5 or before
function dm_widget_button,parent,set_button=set_button,onstring=onstring,offstring=offstring,_extra=extra
    if float(!version.release) ge 5.6 then $
       id=widget_button(parent,_extra=extra,/checked_menu) $
    else $
       id=widget_button(parent,_extra=extra)
    if n_elements(set_button) eq 1 then dm_set_button,id,set_button,onstring=onstring,offstring=offstring
    return,id
end