; $Id: davedat2d__restore.pro,v 1.2 2003/01/14 14:58:54 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST
;
; NAME:_______________________
;   DaveDat2D::restore
;
; PURPOSE:____________________
;   This function is used to 
;   restore all class variables derived from the davePtr back to
;   their initial values. The davePtr class variables always contains
;   the original data.
;
; INPUTS:_____________________
;   NONE
;
; OUTPUTS:____________________
;     return value: 0 signifies failure and 1 success.
;
function DaveDat2D::restore

return, self->resetData()

end
