; $Id: insertstringinstringarray.pro,v 1.1 2003/06/13 18:14:46 azuah Exp $
;===============================================================================
;
; Richard Tumanjong Azuah
; NCNR, NIST Feb, 2003
;
; Insert a scalar string value into a string array at the specified index
; location.
pro insertStringInStringArray, array, value, index
len = n_elements(array)
case index of
    0: array = [value,array]
    else: begin
        if (index ge len -1) then begin
            array = [array,value]
            break
        endif
        array = [array[0:index-1],value,array[index:*]] 
    end
endcase
end
