; $Id: pan_do_the_macro.pro,v 1.1 2003/08/11 19:07:11 dimeo Exp $
function pan_do_the_macro,macro_lines
n_lines = n_elements(macro_lines)
if macro_lines[0] eq '' then return,0
nlines = n_elements(macro_lines)

this_level = routine_names(/level)
main_level = 1
; What are the variable names in the current level?
old_current = routine_names(variables=this_level)
; What are the variable names in the main level?
old_main = routine_names(variables=main_level)
; Get out all of the old $MAIN$ variables and
; put them in the current level....
n_old_main = n_elements(old_main)
if old_main[0] eq "" then begin
	n_old_main = 0
endif else begin
	; put the main level variables in the current level
	for _i = 0,n_old_main-1 do begin
		if n_elements(routine_names(old_main[_i],fetch = main_level)) gt 0 then begin
			value  = routine_names(old_main[_i], fetch = main_level)
			dummy  = routine_names(old_main[_i], value, store = this_level)
		endif
	endfor
endelse
;before_execute = routine_names(variables = this_level)
for _i = 0,nlines-1 do begin
	before_execute = routine_names(variables = this_level)
	r = execute(macro_lines[_i],1)
	after_execute = routine_names(variables = this_level)
	if r ne 1 then begin
		void = dialog_message(!error_state.msg,/error)
		return,0
	endif
; are there any new variables introduced due to execute at this level?
	n_before = n_elements(before_execute)
	n_after = n_elements(after_execute)
	counter = 0L
	if n_before ne n_after then begin
		for _ii = 0,n_after-1 do begin
			whereok = where(before_execute eq after_execute[_ii],count)
			if count eq 0 then begin
				if counter eq 0L then new_var = after_execute[_ii] else $
					new_var = [new_var,after_execute[_ii]]
					counter = counter+1L
			endif
		endfor
; Promote new variables from this level to the $MAIN$ level
		for _ii = 0,counter-1 do begin
			if n_elements(routine_names(new_var[_ii],fetch = this_level)) gt 0 then begin
				value  = routine_names(new_var[_ii], fetch = this_level)
				dummy  = routine_names(new_var[_ii], value, store = main_level)
			endif
		endfor
	endif

; are there any of the same variables in the $MAIN$ level and in the
; current level?  If so then replace $MAIN$ level variables with
; those from the current level.
	new_main = routine_names(variables = main_level)
	new_current = routine_names(variables = this_level)
	counter = 0L
	for _ii = 0,n_elements(new_main)-1 do begin
		whereok = where(new_current eq new_main[_ii],count)
		if count ne 0 then begin
			if counter eq 0L then new_var = new_current[whereok[0]] else $
				new_var = [new_var,new_current[whereok[0]]]
			counter = counter+1L
		endif
	endfor
	for _ii = 0,counter-1 do begin
; get the value from this level
		if n_elements(routine_names(new_var[_ii],fetch = this_level)) gt 0 then begin
			value  = routine_names(new_var[_ii], fetch=this_level)
			; put the value and variable name into the $MAIN$ level
			dummy  = routine_names(new_var[_ii], value, store = main_level)
		endif
	endfor
endfor
return,1
end