;$Id: trifenestra_math.pro,v 1.1 2002/07/02 20:56:32 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::_sum, range, xrange=xrange, yrange=yrange

	if n_elements( range ) eq 4 then begin
		xrange = [ range[0], range[2] ]
		yrange = [ range[1], range[3] ]
	endif

	sum = self.oDave -> sum( xrange=xrange, yrange=yrange )

	self -> _log, string( sum[0] ) + ' +- ' + string( sum[1] )

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::_integrate_2d, range, xrange = xrange, yrange = yrange

	if n_elements( range ) eq 4 then begin
		xrange = [ range[0], range[2] ]
		yrange = [ range[1], range[3] ]
	endif

	int = self.oDave -> integrate_2d( xrange=xrange, yrange=yrange )

	self -> _log, string( int[0] ) + ' +- ' + string( int[1] )

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra_math

end