;==================================================================
;*
pro helper_cw_ow_freshenResults, $	; Used by cw_ow_resol.pro, etc.
	thisWhereWObj, $			; cw_ow_where GUI object
	thisSpecObj, $			; database object class specObj.
	from=thisFrom, $	; which is sensitized 'input', 'header' or 'data'
	value = thisValue, $	; Goes to the text entry box
	label = thisLabel, $	; Goes to the droplist
	tags = thisTags, $
   	name = thisName, $
	units = thisUnits
;/

   message, /info, 'Entered'
   help, thisWhereWObj
   thisWhereWObj -> getProperty, $
	from = thisFrom, $	; which is sensitized 'input', 'header' or 'data'
	label = thisLabel, $ ; Goes to the droplist
	value = thisValue	; Goes to the text entry box

   thisunits = ''
   thisname = ''
   if (thisfrom eq 'input') then begin
     thisTags = thisValue
     thisUnits = strtrim( string(thisValue), 2)
     thisName = thisUnits
     thisLabel = thisUnits
   endif else begin
     thisTags = ['*', thisLabel, '*'] 
     if (thisFrom eq 'header') then begin
       OK = thisSpecObj -> getField(thisTags, units=thisUnits, name=thisName,$
    		   /inHeader)
     endif else begin
       OK = thisSpecObj -> getField(thisTags, units=thisUnits, name=thisName,$
    		   /inData)
     endelse
     if (NOT OK) then message, /info, string($
     	"Failed to get name and units for label=", thislabel) 
     	
   endelse

	
end	

